/***************************************************************
*                                                              *
*           This software is part of the ast package           *
*              Copyright (c) 1992-2000 AT&T Corp.              *
*      and it may only be used by you under license from       *
*                     AT&T Corp. ("AT&T")                      *
*       A copy of the Source Code Agreement is available       *
*              at the AT&T Internet web site URL               *
*                                                              *
*     http://www.research.att.com/sw/license/ast-open.html     *
*                                                              *
*      If you have copied this software without agreeing       *
*      to the terms of the license you are infringing on       *
*         the license and copyright and are violating          *
*             AT&T's intellectual property rights.             *
*                                                              *
*               This software was created by the               *
*               Network Services Research Center               *
*                      AT&T Labs Research                      *
*                       Florham Park NJ                        *
*                                                              *
*             Glenn Fowler <gsf@research.att.com>              *
*              David Korn <dgk@research.att.com>               *
*                                                              *
***************************************************************/

/* : : generated by proto : : */
                  
/*
 * AT&T Research
 *
 * builtin cmd definitions
 */

#ifndef _CMD_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define _CMD_H

#include <ast.h>
#include <error.h>
#include <stak.h>

#if _BLD_cmd && defined(__EXPORT__)
#define extern		__EXPORT__
#endif

extern __MANGLE__ int	b_basename __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_cat __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_chgrp __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_chmod __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_chown __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_cmp __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_comm __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_cp __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_cut __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_dirname __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_expr __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_fmt __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_fold __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_getconf __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_head __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_id __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_join __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_ln __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_logname __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_mkdir __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_mkfifo __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_mv __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_paste __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_pathchk __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_rev __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_rmdir __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_tail __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_tee __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_tty __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_uname __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_uniq __PROTO__((int, char**, __V_*));
extern __MANGLE__ int	b_wc __PROTO__((int, char**, __V_*));

#undef	extern

#if defined(BUILTIN) && !defined(STANDALONE)
#define STANDALONE	BUILTIN
#endif

#ifdef	STANDALONE

#ifndef BUILTIN

/*
 * command initialization
 */

static void
cmdinit __PARAM__((register char** argv, __V_* context, const char* catalog), (argv, context, catalog)) __OTORP__(register char** argv; __V_* context; const char* catalog;){
	register char*	cp;

	NoP(context);
	if (cp = strrchr(argv[0], '/'))
		cp++;
	else
		cp = argv[0];
	error_info.id = cp;
	if (!error_info.catalog)
		error_info.catalog = (char*)catalog;
	opt_info.index = 0;
}

extern __MANGLE__ int	STANDALONE __PROTO__((int, char**, __V_*));

#endif

int
main __PARAM__((int argc, char** argv), (argc, argv)) __OTORP__(int argc; char** argv;){
	return STANDALONE(argc, argv, NiL);
}

#else

#if _BLD_cmd && defined(__EXPORT__)
#define extern		__EXPORT__
#endif

extern __MANGLE__ int	cmdrecurse __PROTO__((int, char**, int, char**));
extern __MANGLE__ void	cmdinit __PROTO__((char**, __V_*, const char*));

#undef	extern

#endif

#endif
